const express = require('express');
const session = require('express-session');
const app = express();
const bodyParser = require('body-parser');

// ใช้ body-parser เพื่อ parse ข้อมูลจากฟอร์ม
app.use(bodyParser.urlencoded({ extended: true }));
app.use(bodyParser.json());

// ตั้งค่า session
app.use(session({
  secret: 'your-secret-key',
  resave: false,
  saveUninitialized: true
}));


app.use(express.urlencoded({ extended: true }));

// หน้าแรก
app.get('/', (req, res) => {
  res.send(`
    <html>
      <head>
        <style>
          body {
            font-family: 'Arial', sans-serif;
            background-color: #f4f4f9;
            margin: 0;
            padding: 0;
            text-align: center;
          }
          h1 {
            color: #007BFF;
            margin-top: 50px;
          }
          p {
            font-size: 1.2em;
          }
          ul {
            list-style-type: none;
            padding: 0;
            font-size: 1.2em;
          }
          ul li {
            margin: 15px 0;
          }
          a {
            text-decoration: none;
            color: #007BFF;
          }
          a:hover {
            text-decoration: underline;
          }
        </style>
      </head>
      <body>
        <h1>Car-Rental-Booking</h1>
        <p>welcome to car-rental-booking</p>
        <ul>
          <li><a href="/register">Register</a></li>
          <li><a href="/login">Login</a></li>
        </ul>
      </body>
    </html>
  `);
});

// หน้า สมัครสมาชิก
app.get('/register', (req, res) => {
  res.send(`
    <html>
      <head>
        <style>
          body {
            font-family: 'Arial', sans-serif;
            background-color: #f4f4f9;
            margin: 0;
            padding: 0;
            text-align: center;
          }
          h1 {
            color: #007BFF;
            margin-top: 50px;
          }
          form {
            background-color: #fff;
            padding: 20px;
            border-radius: 8px;
            box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
            width: 40%;
            margin: 20px auto;
            text-align: left;
          }
          label {
            font-weight: bold;
            display: block;
            margin-bottom: 5px;
          }
          input[type="text"], input[type="password"] {
            width: 100%;
            padding: 10px;
            margin-bottom: 20px;
            border: 1px solid #ccc;
            border-radius: 4px;
          }
          button {
            width: 100%;
            padding: 10px;
            background-color: #007BFF;
            color: white;
            border: none;
            border-radius: 4px;
            font-size: 1.1em;
          }
          button:hover {
            background-color: #0056b3;
          }
        </style>
      </head>
      <body>
        <h1>Register</h1>
    <form action="/register" method="POST">
      <label>Username:</label><br/>
      <input type="text" name="username" required /><br/><br/>
      <label>Email:</label><br/>
      <input type="email" name="email" required /><br/><br/>
      <label>Password:</label><br/>
      <input type="password" name="password" required /><br/><br/>
      <button type="submit">Register</button>
    </form>
      </body>
    </html>
  `);
});

// สมัครสมาชิก - POST
// สมัครสมาชิก
app.post('/register', (req, res) => {
  const { username, password, email } = req.body;
  
  // บันทึกข้อมูลผู้ใช้ใหม่ (แนะนำให้เก็บในฐานข้อมูล)
  req.session.user = { username, email };  // เก็บข้อมูลใน session
  
  res.redirect('/rent');  // หลังจากสมัครสมาชิกเสร็จ ให้ไปที่หน้า /rent
});


// หน้า เข้าสู่ระบบ
app.get('/login', (req, res) => {
  res.send(`
    <html>
      <head>
        <style>
          body {
            font-family: 'Arial', sans-serif;
            background-color: #f4f4f9;
            margin: 0;
            padding: 0;
            text-align: center;
          }
          h1 {
            color: #007BFF;
            margin-top: 50px;
          }
          form {
            background-color: #fff;
            padding: 20px;
            border-radius: 8px;
            box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
            width: 40%;
            margin: 20px auto;
            text-align: left;
          }
          label {
            font-weight: bold;
            display: block;
            margin-bottom: 5px;
          }
          input[type="text"], input[type="password"] {
            width: 100%;
            padding: 10px;
            margin-bottom: 20px;
            border: 1px solid #ccc;
            border-radius: 4px;
          }
          button {
            width: 100%;
            padding: 10px;
            background-color: #007BFF;
            color: white;
            border: none;
            border-radius: 4px;
            font-size: 1.1em;
          }
          button:hover {
            background-color: #0056b3;
          }
        </style>
      </head>
      <body>
        <h1>Login</h1>
        <form action="/login" method="POST">
          <label>Username:</label><br/>
          <input type="text" name="username" required /><br/><br/>
          <label>Password:</label><br/>
          <input type="password" name="password" required /><br/><br/>
          <button type="submit">Login</button>
        </form>
      </body>
    </html>
  `);
});

// เข้าสู่ระบบ - POST
// เข้าสู่ระบบ
app.post('/login', (req, res) => {
  const { username, password } = req.body;
  
  // ตรวจสอบข้อมูลผู้ใช้ (แนะนำให้เช็คจากฐานข้อมูล)
  if (username === 'testuser' && password === 'password') {
    req.session.user = { username };
    return res.redirect('/rent');  // เปลี่ยนเส้นทางไปที่หน้า /rent หลังจากเข้าสู่ระบบ
  }
  res.redirect('/rent');
});


// หน้าหลักหลังจากเข้าสู่ระบบ
app.get('/dashboard', (req, res) => {
  // ตรวจสอบว่าผู้ใช้ล็อกอินแล้วหรือไม่
  if (!req.session.user) {
    return res.redirect('/login');
  }

  res.send(`
    <html>
      <head>
        <style>
          body {
            font-family: 'Arial', sans-serif;
            background-color: #f4f4f9;
            margin: 0;
            padding: 0;
            text-align: center;
          }
          h1 {
            color: #007BFF;
            margin-top: 50px;
          }
          ul {
            list-style-type: none;
            padding: 0;
            font-size: 1.2em;
          }
          ul li {
            margin: 15px 0;
          }
          a {
            text-decoration: none;
            color: #007BFF;
          }
          a:hover {
            text-decoration: underline;
          }
        </style>
      </head>
      <body>
        <h1>Welcome, ${req.session.user.username}</h1>
        <ul>
          <li><a href="/rentals">car rental booking</a></li>
          <li><a href="/rent">booking</a></li>
        </ul>
      </body>
    </html>
  `);
});

// จองรถ
// จองรถ
app.get('/rent', (req, res) => {
  if (!req.session.user) {
    return res.redirect('/login');  // ถ้ายังไม่ได้เข้าสู่ระบบ ให้ไปที่หน้า login
  }

  res.send(`
    <html>
      <head>
        <style>
          body {
            font-family: 'Arial', sans-serif;
            background-color: #f4f4f9;
            margin: 0;
            padding: 0;
            text-align: center;
          }
          h1 {
            color: #007BFF;
            margin-top: 50px;
          }
          form {
            background-color: #fff;
            padding: 20px;
            border-radius: 8px;
            box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
            width: 40%;
            margin: 20px auto;
            text-align: left;
          }
          label {
            font-weight: bold;
            display: block;
            margin-bottom: 5px;
          }
          input[type="text"], input[type="date"] {
            width: 100%;
            padding: 10px;
            margin-bottom: 20px;
            border: 1px solid #ccc;
            border-radius: 4px;
          }
          button {
            width: 100%;
            padding: 10px;
            background-color: #007BFF;
            color: white;
            border: none;
            border-radius: 4px;
            font-size: 1.1em;
          }
          button:hover {
            background-color: #0056b3;
          }
        </style>
      </head>
      <body>
        <h1>จองรถ</h1>
        <form action="/rent" method="POST">
          <label>Car Model:</label><br/>
          <input type="text" name="carModel" required /><br/><br/>
          <label>Rental Start Date:</label><br/>
          <input type="date" name="startDate" required /><br/><br/>
          <label>Rental End Date:</label><br/>
          <input type="date" name="endDate" required /><br/><br/>
          <button type="submit">จองรถ</button>
        </form>
      </body>
    </html>
  `);
});
// จองรถ (POST)
app.post('/rent', (req, res) => {
  if (!req.session.user) {
    return res.redirect('/login');  // ถ้าไม่ได้เข้าสู่ระบบ จะกลับไปหน้า login
  }

  const { carModel, startDate, endDate } = req.body;
  
  // สมมุติว่าเราจะบันทึกการจองในฐานข้อมูล หรือเก็บใน session
  const rental = {
    carModel,
    startDate,
    endDate
  };
  if (!req.session.rentals) {
    req.session.rentals = [];
  }

  req.session.rentals.push(rental); 
  // ในกรณีนี้, สามารถเก็บข้อมูลจองในฐานข้อมูล
  // สมมุติว่าเราบันทึกได้แล้ว
  // การจองเสร็จแล้วจะเปลี่ยนเส้นทางไปที่หน้ารายการจอง
  res.redirect('/rentals');  // เมื่อทำการจองเสร็จแล้วให้ไปที่หน้า /rentals
});



// รายการจอง
// รายการจอง
app.get('/rentals', (req, res) => {
  if (!req.session.user) {
    return res.redirect('/login');  // ถ้าไม่ได้เข้าสู่ระบบ ให้กลับไปที่หน้า login
  }

  // สมมุติข้อมูลการจอง
  const rentals = [
    { id: 1, carModel: 'Toyota Camry', startDate: '2025-04-01', endDate: '2025-04-07' },
    { id: 2, carModel: 'Honda Civic', startDate: '2025-04-05', endDate: '2025-04-10' },
  ];

  let html = `<h1>My booking</h1>`;
  html += `<table border="1" cellpadding="5" cellspacing="0">
              <tr>
                <th>ID</th>
                <th>Car Model</th>
                <th>Start Date</th>
                <th>End Date</th>
              </tr>`;

  rentals.forEach(rental => {
    html += `<tr>
                <td>${rental.id}</td>
                <td>${rental.carModel}</td>
                <td>${rental.startDate}</td>
                <td>${rental.endDate}</td>
              </tr>`;
  });

  html += `</table><br/><a href="/dashboard">Go Back</a><br/>
          <a href="/logout"><button class="logout-btn">Logout</button></a>`;
  res.send(html);
});

// Route สำหรับ Logout
app.get('/logout', (req, res) => {
  req.session.destroy((err) => {
    if (err) {
      return res.status(500).send('ไม่สามารถออกจากระบบได้');
    }

    // เมื่อออกจากระบบแล้วให้ redirect กลับไปที่หน้าแรกหรือหน้า login
    res.redirect('/login');
  });
});



// เริ่มเซิร์ฟเวอร์
app.listen(3000, () => {
  console.log('Server is running on http://localhost:3000');
});
